#!/bin/bash

# Verzeichnis in dem Die Dateien abgelegt werden sollen
FILE_DIR="$QA_PFAD/tmp"
mkdir -p $FILE_DIR

# Dateiname
export FILE_NAME="Testfall_Protokoll"

# Masken TID
export MASKEN_TID=37020

# Datum für das Feld "Ab Datum"
export DATUM_EXEC=$(date "+%d.%m.%Y")

# Masken Parameter
export MASK_PARAM="Ausführungs-Status=1,2&Ab Datum=${DATUM_EXEC}"


# ExecuteMask funktioniert nur im WEB-INF Ordner
cd $WEBAPP/WEB-INF

echo CMD -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask -tid:$MASKEN_TID -out:$FILE_DIR/$FILE_NAME.pdf -user:admin "-params:${MASK_PARAM}&stylesheet=tabelle_fo_pdf.xsl&contenttype=application/pdf" -logger:$SUPERX_DIR/db/conf/logging.properties

# PDF
java -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask -tid:$MASKEN_TID -out:$FILE_DIR/$FILE_NAME.pdf -user:admin "-params:${MASK_PARAM}&stylesheet=tabelle_fo_pdf.xsl&contenttype=application/pdf" -logger:$SUPERX_DIR/db/conf/logging.properties

# XML
#java -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask -tid:$MASKEN_TID -out:$FILE_DIR/$FILE_NAME.xml -user:admin "-params:${MASK_PARAM}&stylesheet=tabelle_fo_pdf.xsl&contenttype=application/vnd.openxmlformats-officedocument.spreadsheetml.sheet" -logger:$SUPERX_DIR/db/conf/logging.properties

# CSV
java -cp "$JDBC_CLASSPATH" $JAVA_OPTS de.superx.bin.ExecuteMask -tid:$MASKEN_TID -out:$FILE_DIR/$FILE_NAME.csv -user:admin "-params:${MASK_PARAM}&stylesheet=tabelle_fo_pdf.xsl&contenttype=text/csv" -logger:$SUPERX_DIR/db/conf/logging.properties

# Verzeichnis in dem die Dateien abgelegt wurden. Zum zählen und verschicken.
cd $FILE_DIR
sed -i 's/\^/ \| /g' $FILE_DIR/$FILE_NAME.csv

#Zuerst Warnungen und Fehler zählen
export W_ANZ=$(grep -c Warnung $FILE_DIR/$FILE_NAME.csv)
export F_ANZ=$(grep -c Fehler $FILE_DIR/$FILE_NAME.csv)


#Mail Versand
cat $FILE_DIR/$FILE_NAME.csv | $MAILPROG -s "Testfall-Protokoll | $W_ANZ Warnungen | $F_ANZ Fehler" -a $FILE_DIR/$FILE_NAME.pdf "${LOGMAIL}"


